* [PATCH] elf: Add ld.so test with non-existing program name
@ 2024-04-08 15:48 Florian Weimer
2024-04-08 15:56 ` H.J. Lu
2024-04-08 16:40 ` Florian Weimer
0 siblings, 2 replies; 3+ messages in thread
From: Florian Weimer @ 2024-04-08 15:48 UTC (permalink / raw)
To: libc-alpha
None of the existing tests seem to cover the case where
_dl_signal_error is called without an active error handler.
The new elf/tst-rtld-does-not-exist test triggers such a
_dl_signal_error call from _dl_map_object.
---
elf/Makefile | 7 +++++++
elf/tst-rtld-does-not-exist.sh | 38 ++++++++++++++++++++++++++++++++++++++
2 files changed, 45 insertions(+)
diff --git a/elf/Makefile b/elf/Makefile
index 4f1903391a..6dad11bcfb 100644
--- a/elf/Makefile
+++ b/elf/Makefile
@@ -621,6 +621,13 @@ $(objpfx)tst-valgrind-smoke.out: tst-valgrind-smoke.sh $(objpfx)ld.so $(objpfx)v
'$(run-program-env)' '$(rpath-link)' $(objpfx)valgrind-test \
'$(valgrind-suppressions-tst-valgrind-smoke)' > $@; $(evaluate-test)
+ifeq ($(run-built-tests),yes)
+tests-special += $(objpfx)tst-rtld-does-not-exist.out
+endif
+$(objpfx)tst-rtld-does-not-exist.out: tst-rtld-does-not-exist.sh $(objpfx)ld.so
+ $(SHELL) $< $(objpfx)ld.so > $@; \
+ $(evaluate-test)
+
tests += $(tests-execstack-$(have-z-execstack))
ifeq ($(run-built-tests),yes)
tests-special += \
diff --git a/elf/tst-rtld-does-not-exist.sh b/elf/tst-rtld-does-not-exist.sh
new file mode 100644
index 0000000000..7b3ba05702
--- /dev/null
+++ b/elf/tst-rtld-does-not-exist.sh
@@ -0,0 +1,38 @@
+#!/bin/sh
+# Check that running ld.so with a non-existing file prints an error.
+# Copyright (C) 2024 Free Software Foundation, Inc.
+# This file is part of the GNU C Library.
+
+# The GNU C Library is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Lesser General Public
+# License as published by the Free Software Foundation; either
+# version 2.1 of the License, or (at your option) any later version.
+
+# The GNU C Library is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# Lesser General Public License for more details.
+
+# You should have received a copy of the GNU Lesser General Public
+# License along with the GNU C Library; if not, see
+# <https://www.gnu.org/licenses/>.
+
+export LC_ALL=C
+
+rtld="$1"
+tmp_out="$(mktemp)"
+
+$rtld program-does-not-exist 2>"$tmp_out"
+status=$?
+echo "$rtld exit status: $status"
+echo "output (with expected error):"
+cat "$tmp_out"
+
+if test $status -eq 127 \
+ && grep -q "^program-does-not-exist: error while loading shared libraries: program-does-not-exist: cannot open shared object file$" "$tmp_out" \
+ && test "$(wc -l < "$tmp_out")" -eq 1 ; then
+ status=0
+else
+ status=1
+fi
+exit $status
base-commit: f8d8b1b1e6d3b8b93f224efc796b7ea083fdb83f
^ permalink raw reply [flat|nested] 3+ messages in thread
* Re: [PATCH] elf: Add ld.so test with non-existing program name
2024-04-08 15:48 [PATCH] elf: Add ld.so test with non-existing program name Florian Weimer
@ 2024-04-08 15:56 ` H.J. Lu
2024-04-08 16:40 ` Florian Weimer
1 sibling, 0 replies; 3+ messages in thread
From: H.J. Lu @ 2024-04-08 15:56 UTC (permalink / raw)
To: Florian Weimer; +Cc: libc-alpha
On Mon, Apr 8, 2024 at 8:48 AM Florian Weimer <fweimer@redhat.com> wrote:
>
> None of the existing tests seem to cover the case where
> _dl_signal_error is called without an active error handler.
> The new elf/tst-rtld-does-not-exist test triggers such a
> _dl_signal_error call from _dl_map_object.
>
> ---
> elf/Makefile | 7 +++++++
> elf/tst-rtld-does-not-exist.sh | 38 ++++++++++++++++++++++++++++++++++++++
> 2 files changed, 45 insertions(+)
>
> diff --git a/elf/Makefile b/elf/Makefile
> index 4f1903391a..6dad11bcfb 100644
> --- a/elf/Makefile
> +++ b/elf/Makefile
> @@ -621,6 +621,13 @@ $(objpfx)tst-valgrind-smoke.out: tst-valgrind-smoke.sh $(objpfx)ld.so $(objpfx)v
> '$(run-program-env)' '$(rpath-link)' $(objpfx)valgrind-test \
> '$(valgrind-suppressions-tst-valgrind-smoke)' > $@; $(evaluate-test)
>
> +ifeq ($(run-built-tests),yes)
> +tests-special += $(objpfx)tst-rtld-does-not-exist.out
> +endif
> +$(objpfx)tst-rtld-does-not-exist.out: tst-rtld-does-not-exist.sh $(objpfx)ld.so
> + $(SHELL) $< $(objpfx)ld.so > $@; \
> + $(evaluate-test)
> +
> tests += $(tests-execstack-$(have-z-execstack))
> ifeq ($(run-built-tests),yes)
> tests-special += \
> diff --git a/elf/tst-rtld-does-not-exist.sh b/elf/tst-rtld-does-not-exist.sh
> new file mode 100644
> index 0000000000..7b3ba05702
> --- /dev/null
> +++ b/elf/tst-rtld-does-not-exist.sh
> @@ -0,0 +1,38 @@
> +#!/bin/sh
> +# Check that running ld.so with a non-existing file prints an error.
> +# Copyright (C) 2024 Free Software Foundation, Inc.
> +# This file is part of the GNU C Library.
> +
> +# The GNU C Library is free software; you can redistribute it and/or
> +# modify it under the terms of the GNU Lesser General Public
> +# License as published by the Free Software Foundation; either
> +# version 2.1 of the License, or (at your option) any later version.
> +
> +# The GNU C Library is distributed in the hope that it will be useful,
> +# but WITHOUT ANY WARRANTY; without even the implied warranty of
> +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
> +# Lesser General Public License for more details.
> +
> +# You should have received a copy of the GNU Lesser General Public
> +# License along with the GNU C Library; if not, see
> +# <https://www.gnu.org/licenses/>.
> +
> +export LC_ALL=C
> +
> +rtld="$1"
> +tmp_out="$(mktemp)"
> +
> +$rtld program-does-not-exist 2>"$tmp_out"
> +status=$?
> +echo "$rtld exit status: $status"
> +echo "output (with expected error):"
> +cat "$tmp_out"
> +
> +if test $status -eq 127 \
> + && grep -q "^program-does-not-exist: error while loading shared libraries: program-does-not-exist: cannot open shared object file$" "$tmp_out" \
> + && test "$(wc -l < "$tmp_out")" -eq 1 ; then
> + status=0
> +else
> + status=1
> +fi
> +exit $status
>
> base-commit: f8d8b1b1e6d3b8b93f224efc796b7ea083fdb83f
>
LGTM.
Reviewed-by: H.J. Lu <hjl.tools@gmail.com>
Thanks.
--
H.J.
^ permalink raw reply [flat|nested] 3+ messages in thread
* Re: [PATCH] elf: Add ld.so test with non-existing program name
2024-04-08 15:48 [PATCH] elf: Add ld.so test with non-existing program name Florian Weimer
2024-04-08 15:56 ` H.J. Lu
@ 2024-04-08 16:40 ` Florian Weimer
1 sibling, 0 replies; 3+ messages in thread
From: Florian Weimer @ 2024-04-08 16:40 UTC (permalink / raw)
To: libc-alpha
* Florian Weimer:
> None of the existing tests seem to cover the case where
> _dl_signal_error is called without an active error handler.
> The new elf/tst-rtld-does-not-exist test triggers such a
> _dl_signal_error call from _dl_map_object.
>
> ---
> elf/Makefile | 7 +++++++
> elf/tst-rtld-does-not-exist.sh | 38 ++++++++++++++++++++++++++++++++++++++
> 2 files changed, 45 insertions(+)
Sorry, forgot to delete the temporary file. Will send a new version.
Florian
^ permalink raw reply [flat|nested] 3+ messages in thread
end of thread, other threads:[~2024-04-08 16:41 UTC | newest]
Thread overview: 3+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2024-04-08 15:48 [PATCH] elf: Add ld.so test with non-existing program name Florian Weimer
2024-04-08 15:56 ` H.J. Lu
2024-04-08 16:40 ` Florian Weimer
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).